\ Misc. SOL utilities
\ By Nils M Holm, 2004

\d -lex ( a a -- f ) t-- | compare lexicon headers
: -lex ( a a -- f ) count 1+ swap 1- swap -text 0= ;

\d @find ( a a -- a|0 ) t-- | find word in partial lexicon
: @find ( a a -- a|0 ) begin dup while
    2dup l>code >name -lex if nip exit then
  @ repeat nip ;

\d check ( -- ) t-- | check lexicon for conflicts
: check ( -- ) lexicon @ begin dup while
    dup dup l>code >name swap @ @find if
      l>code .w cr quit then
    [char] . emit
  @ repeat drop ;

\d ddump ( blk -- ) t-- | print block dump
: ddump ( blk -- ) block  4 for
    dup b/blk 4 / 1- dump  i 1 <> if
      cr ." -- cr = more --"
      key [hex] 0d <> if
        unfor drop exit then then
  b/blk 4 / + next  drop ;

\d greprec ( a rec -- f ) t-- | grep record for string
: greprec ( a rec -- f) b/r for  2dup swap count
    -text 0= if  2drop 1 unfor exit then  1+ next 2drop 0 ;

\d recaddr ( n -- a ) t-- | convert record# to pointer
: recaddr ( n -- a ) r/blk swap - b/r * dtb + ;

\d grepblk ( a blk -- ) t-- | grep block for string
: grepblk ( a blk -- ) block drop  r/blk for
    dup i recaddr greprec if 
      cr blk @ 5 .r  space  i recaddr b/r type then
    next  drop ;

0 var pattern b/r allot

\d scopy ( src dest -- ) t-- | copy string
: scopy ( src dest -- ) swap count 1+ >r  1- swap  r> cmove ;

\d grep ( blk -- n ) t-i | grep lblock for string
: grep" ( blk -- ) [char] " word  pattern scopy  begin
    pattern over grepblk  lhdr not l> @ 0= or if drop exit then
    drop l> @ again ;

' grep" alias grep
